<?php

/*
 * Flatnuke http://www.flatnuke.org/
 * Upgrade script to 3.0.0 version
 *
 * Author/s:	Marco Segato <segatom@users.sourceforge.net>
 * 		Aldo Boccacci <zorba_@tin.it>
 */

// include Flatnuke APIs
include_once("functions.php");
include_once("shared.php");
include_once("forum/include/ff_functions.php");

create_fn_constants();

// move /misc directory to /var
if(file_exists("misc") AND !file_exists(get_fn_dir("var"))) {
	rename("misc", get_fn_dir("var"));
}

// try to create symlink /misc->/var
if(is_writable("./") AND !file_exists("misc") AND file_exists(get_fn_dir("var"))) {
	@symlink(get_fn_dir("var"), "misc");
}

// update directory in forum files
update_forum_stats();

echo "<b>Avvio il processo di upgrade delle news</b>:<br /><br />";

if (is_writable("sections/none_News/")){
	if (!is_dir("sections/none_News/none_newsdata")){
		fn_mkdir("sections/none_News/none_newsdata",0777);
		echo "Ho creato la cartella sections/none_News/none_newsdata<br /><br />";
	
	}
}
else {
	echo "<b>Errore!</b> La cartella <b>sections/none_News/</b> non  scrivibile, controllare i permessi e poi ripetere la procedura di upgrade.";
	return;
}

$newsarray = array();
$handle  = opendir('news');
while ($file = readdir($handle)) {
	if (!( $file=="." or $file==".." ) and (!ereg("^\.",$file) and ($file!="CVS")) and eregi("xml$",get_file_extension($file)) ) {
		array_push($newsarray, $file);
	}
}
closedir($handle);

for ($count=0;$count<count($newsarray);$count++){
// 	echo $newsarray[$count];
	$data = load_news_upgrade($newsarray[$count]);
	save_news_upgrade(eregi_replace("\.xml","",$newsarray[$count]),$data);
	echo "Ho convertito la news: <b>".eregi_replace("\.xml","",$newsarray[$count])."</b><br />";

}

echo "<br /><br /><b>L'upgrade delle news  terminato.</b> Quando sarete assolutamente sicuri che tutte le news siano state convertite correttamente, eliminate tutti i file presenti nella cartella news/";

function load_news_upgrade($newsfile){
	if ($newsfile=="NULL") return;
	if (!is_file("news/".$newsfile)) return NULL;
	if (!check_path($newsfile,"","nonull"));
	
	$pathnews= "news/";
	$data = array();
	$string = "";
	$string = get_file($pathnews."/".$newsfile);
	
	//CARICO LE PROPRIET DELLA NEWS
	
	//titolo della news
	$newstitle = "";
	$newstitle = get_xml_element("fn:title",$string);
	if (check_var($newstitle,"text"))
		$data['title'] = $newstitle;
	else $data['title'] = "";
	
	//categoria news
	$newscategory = "";
	$newscategory = get_xml_element("fn:avatar",$string);
	if (check_var($newscategory,"text"))
		$data['category'] = $newscategory;
	else $data['category'] = "";
	
	//Tags
	/* --> Commentato da Marco Segato: non serve, nelle versioni
	 * antecedenti alla 3.0 il nodo <fn:tags> non esiste!
	$data['tags'] = array();
	$newstagsok = array();
	$tags_string="";
	$tags_string = get_xml_element("fn:tags",$string);
	$newstags = explode(",",$tags_string);
	
	$count_tags=0;
	for ($count_tags=0;$count_tags<count($newstags);$count_tags++){
		if (check_var($newstags[$count_tags],"text")){
			$data['tags'][]= trim($newstags[$count_tags]);
		}
	} */
	
	//letture news
	$newsreads = "";
	$newsreads = get_xml_element("fn:reads",$string);
	$newsreads=trim($newsreads);
	if (check_var($newsreads,"digit"))
		$data['reads'] = $newsreads;
	else $data['reads'] = "0";
	
	//autore news
	/* --> Commentato da Marco Segato: non serve, nelle versioni
	 * antecedenti alla 3.0 il nodo <fn:by> per la notizia non esiste!
	$newsby = "";
	$newsby = get_xml_element("fn:by",$string);
	if (check_var($newsby,"text"))
		$data['by'] = $newsby;
	else $data['by'] = "";*/
	
	//DATA
	//al momento la leggo dal nome del file
	$newsdate ="";
	$newsdate = trim(eregi_replace("\.php","",$newsfile));
	if (!check_var($newsdate,"digit")) $newsdate="0";
	$data['date'] =$newsdate;
	
	//autore ultima modifica
	$newslasteditby = "";
	$newslasteditby = get_xml_element("fn:lasteditby",$string);
	if (check_var($newslasteditby,"text"))
		$data['lasteditby'] = $newslasteditby;
	else $data['lasteditby'] = "";
	
	//data ultima modifica
	$newslastedit = "";
	$newslastedit = get_xml_element("fn:lastedit",$string);
	if (check_var($newslastedit,"digit"))
		$data['lastedit'] = $newslastedit;
	else $data['lastedit'] = "";
	
	
	//la news  nascosta?
	$newshidden = "false";
	$newshidden = get_xml_element("fn:hidden",$string);
	if (check_var($newshidden,"boolean"))
		$data['hidden'] = $newshidden;
	else $data['hidden'] = "false";
	
	//livello della news
	$newslevel = "";
	$newslevel = get_xml_element("fn:level",$string);
	if ($newslevel>-1 and $newslevel<11)
		$data['level'] = $newslevel;
	else $data['level'] = "-1";
	
	//header della news
	$newsheader = "";
	$newsheader = get_xml_element("fn:header",$string);
	$newsheader = fn_purge_html_string($newsheader);
	$data['header'] = $newsheader;
	
	//header della news
	$newsbody = "";
	$newsbody = get_xml_element("fn:body",$string);
	$newsbody = fn_purge_html_string($newsbody);
	$data['body'] = $newsbody;
	
	//COMMENTI
	$data['comments']=array();
	$comments_string= "";
	$comments_string = get_xml_element("fn:comments",$string);
// 	echo $comments_string;
	$comments_array = get_xml_array("fn:comment",$comments_string);
// print_r($comments_array);
	for ($count_comments=0;$count_comments<count($comments_array);$count_comments++){
		$comment = $comments_array[$count_comments];
		
		//Autore del commento
		$cmby = "";
		$cmby = get_xml_element("fn:by",$comment);
		if (check_var($cmby,"text"))
			$data['comments'][$count_comments]['cmby'] = $cmby;
		else $data['comments'][$count_comments]['cmby'] = "";
		
		//data del commento
		$cmdate = "";
		$cmdate = trim(get_xml_element("fn:date",$comment));
		if (check_var($cmdate,"digit"))
			$data['comments'][$count_comments]['cmdate'] = $cmdate;
		else $data['comments'][$count_comments]['cmdate'] = "";
		
		//Autore dell'ultima modifica al commento
		$cmlasteditby = "";
		$cmlasteditby = get_xml_element("fn:cmlasteditby",$comment);
		if (check_var($cmlasteditby,"text"))
			$data['comments'][$count_comments]['cmlasteditby'] = $cmlasteditby;
		else $data['comments'][$count_comments]['cmlasteditby'] = "";
		
		//data dell'ultima modifica al commento
		$cmlastedit = "";
		$cmlastedit = trim(get_xml_element("fn:cmlastedit",$comment));
		if (check_var($cmlastedit,"digit"))
			$data['comments'][$count_comments]['cmlastedit'] = $cmlastedit;
		else $data['comments'][$count_comments]['cmlastedit'] = "";
		
		//il commento
		$cmpost = "";
		$cmpost = get_xml_element("fn:post",$comment);
		$cmpost= strip_tags($cmpost);
		$data['comments'][$count_comments]['cmpost'] = $cmpost;
	
	}

	return $data;
}

/**
 * Funzione di salvataggio della news
 * @param string $news il numero identificativo della news
 * @param array $data l'array con tutti i dati della news
 * @author Aldo Boccacci
 * @since 0.1
 */
function save_news_upgrade($news,$data){
// 	if (!is_array());
	$news = getparam($news,PAR_NULL,SAN_FLAT);
	if (!check_var($news,"digit")) fn_die("NEWS","\$news time is not valid! (".strip_tags($news).") ",__FILE__,__LINE__);
	
	if (!is_array($data)) fn_die("NEWS","\$data must be an array()! ",__FILE__,__LINE__);

	//controllo i dati
	//Il titolo della news
	if (isset($data['title'])){
		$title = stripslashes(strip_tags($data['title']));
	}
	else $title = "";

	if (isset($data['category'])){
		$category = stripslashes(strip_tags($data['category']));
		if (!check_path($category,"","false")) $category = "nonews.png";
	}
	else $category = "nonews.png";
	
// 	$data['tags'][0]=eregi_replace("\.png$","",$category);
	$data['tags'][1]="";
	$tags ="";
	if (isset($data['tags'])){
		for ($count_tags=0;$count_tags<count($data['tags']);$count_tags++){
			$tag = stripslashes(strip_tags($data['tags'][$count_tags]));
// 			if ($count_tags<count($data['tags'])-1)
				$tags .= "\t\t<tag>$tag</tag>\n";
		}
	
	}

	if (isset($data['reads'])){
// 		echo $data['reads'];
		$reads = stripslashes(strip_tags($data['reads']));
		if (!check_var($reads,"digit")) $reads=0;
	}
	else $reads = "0";

	if (isset($data['by'])){
		$by = stripslashes(strip_tags($data['by']));
		if (!check_username($by)) $by = "";
	}
	else $by = "";

	if (isset($data['date'])){
		$date = stripslashes(strip_tags($data['date']));
		if (!check_var($date,"digit")) {
			$date = $news;
			fnlog("NEWS", "ERROR: \$date (".strip_tags($date).") is not valid. Set date to \$news variable");
		}
	}
	else {
		$date = $news;
		fnlog("NEWS", "ERROR: \$date (".strip_tags($date).") is not set. Set date to \$news variable");
	}


	if (isset($data['lasteditby'])){
		$lasteditby = stripslashes(strip_tags($data['lasteditby']));
		if (!check_username($lasteditby)) $lasteditby = "";
	}
	else $lasteditby = "";
	

	if (isset($data['lastedit'])){
		$lastedit = stripslashes(strip_tags($data['lastedit']));
		if (!check_var($lastedit,"digit")) {
			$lastedit = $news;
			fnlog("NEWS", "ERROR: \$lastedit (".strip_tags($lastedit).") is not valid. Set lastedit to \$news variable");
		}
	}
	else {
		$lastedit = $news;
		fnlog("NEWS", "ERROR: \$lastedit (".strip_tags($lastedit).") is not set. Set lastedit to \$news variable");
	}


	if (isset($data['hidden'])){
		$hidden = stripslashes(strip_tags($data['hidden']));
		if (!check_var($hidden,"boolean")) $hidden = "0";
	}
	else $hidden = "0";

	if (isset($data['level'])){
		$level = stripslashes(strip_tags($data['level']));
		if (check_var($level,"digit") and $level<=10 and $level>=0) {//OK
		}
		else if ($level == "-1"){//OK
		}
		else $level="-1";
	}
	else $level = "-1";

	if (isset($data['header'])){
		$header = stripslashes(fn_purge_html_string($data['header'],"user"));
	}
	else $header="";

	if (isset($data['body'])){
		$body = stripslashes(fn_purge_html_string($data['body'],"user"));
	}
	else $body="";




	$datastring = "";
	$datastring = "<news xmlns:fn=\"http://flatnuke.sourceforge.net/news\">
	<title>$title</title>
	<category>$category</category>
	<tags>\n$tags\t</tags>
	<reads>$reads</reads>
	<by>$by</by>
	<date>$date</date>
	<lasteditby>$lasteditby</lasteditby>
	<lastedit>$lastedit</lastedit>
	<hidden>$hidden</hidden>
	<level>$level</level>
	<header>$header</header>
	<body>$body</body>
	<comments>";

	//COMMENTI
	$comment = array();
	foreach ($data['comments'] as $comment){
		if (isset($comment['cmby'])){
			$cmby = stripslashes(strip_tags($comment['cmby']));
			if (!check_username($cmby)){
				$cmby="";
				fnlog("NEWS","Variable \$cmby (".$cmby.") is not valid!");
			}
		}
		else $cmby="";
		
		if (isset($comment['cmdate'])){
			$cmdate = stripslashes(strip_tags($comment['cmdate']));
			if (!check_var($cmdate,"digit")){
				$cmdate="";
				fnlog("NEWS","Variable \$cmdate (".$cmdate.") is not valid!");
			}
		}
		else $cmdate="";
		
		if (isset($comment['cmlasteditby'])){
			$cmlasteditby = stripslashes(strip_tags($comment['cmlasteditby']));
			if (!check_username($cmlasteditby)){
				$cmlasteditby="";
				fnlog("NEWS","Variable \$cmlasteditby (".$cmlasteditby.") is not valid!");
			}
		}
		else $cmlasteditby="";
		
		if (isset($comment['cmlastedit'])){
			$cmlastedit = stripslashes(strip_tags($comment['cmlastedit']));
			if (!check_var($cmlastedit,"digit")){
				$cmlastedit="";
				fnlog("NEWS","Variable \$cmlastedit (".$cmlastedit.") is not valid!");
			}
		}
		else $cmlastedit="";
		
		if (isset($comment['cmpost'])){
			$cmpost = stripslashes(strip_tags($comment['cmpost']));
		}
		else $cmpost="";
		
		$datastring .= "\n\t\t<comment>
			<cmby>$cmby</cmby>
			<cmdate>$cmdate</cmdate>
			<cmlasteditby>$cmlasteditby</cmlasteditby>
			<cmlastedit>$cmlastedit</cmlastedit>
			<cmpost>$cmpost</cmpost>
		</comment>";
		
	}

	//Completo la stringa da scrivere
	$datastring .= "\n\t</comments>
</news>";

	if (eregi("\<\?",$datastring) or eregi("\?\>",$datastring)) fn_die("\$datastring cannot contains php tags! ",__FILE__,__LINE__);
	fnwrite("sections/none_News/none_newsdata/$news.fn.php","<?xml version='1.0' encoding='ISO8859-1' ?>\n".$datastring,"w",array("nonull"));
	
// 	fnlog("NEWS","news $news saved by ".get_username());


}
//thanks to Roberto Balbi
save_news_list("none_News/");
// end of upgrade
// (Inserire un controllo?)
echo "<h1>FLATNUKE UPGRADE OK</h1>";
?>